/*	Hurler widget
	Andrew Hedges, andrew@hedges.name
	Version 1.0, 4 March 2009
*/
(function () {
	var
		browsers,
		apiURL,
		command,
		inDash,
		browser,
		onshow,
		onhide,
		getURL,
		hurlURL,
		localize,
		init
	;
	
	browsers = ['Safari', 'Firefox', 'Camino', 'Opera', 'Flock', 'OmniWeb'];
	apiURL   = 'http://www.hurl.ws/api/?user=hurler&url=';
	command  = 'ps xww | grep ';
	inDash   = false;
	
	onshow = function () {
		inDash = true;
		isActivated();
	};
	
	onhide = function () {
		inDash = false;
	};
	
	isActivated = function () {
		var cmd;
		cmd = widget.system(command + browser, function (obj) {
			if (obj.outputString.indexOf(browser + '.app') > -1) {
				getURL();
			} else {
				$('input[name=url]').val('');
			}
		});
	};
	
	getURL = function () {
		widget.system('assets/getURL-' + browser + '.sh', function (obj) {
			var url;
			url = obj.outputString.length < 5 ? 'http://andrew.hedges.name/widgets/' : obj.outputString;
			$('input[name=url]').val(url);
		});
	};
	
	hurlURL = function () {
		$.ajax({
			url      : apiURL + encodeURIComponent($('input[name=url]').val()),
			method   : 'get',
			dataType : 'text',
			success  : function (url) {
				url = url.replace(/www\./, '');
				$('input[name=url]').val(url);
				widget.system("/bin/echo -n '" + url + "' | /usr/bin/pbcopy", function () {
					if (false === inDash) {
						widget.system('assets/growl-enabled.sh', function (obj) {
							var cmd;
							cmd = '/usr/bin/osascript assets/growl-notify.scpt "' + url + '"';
							if (1 === +obj.outputString) widget.system(cmd, function (obj) {});
						});
					}
				});
			},
			error    : function () {
				$('input[name=url]').val(localize('An error occurred. Please try again.'));
			}
		});
	};
	
	localize = function (str) {
		try {
			var str = LocalizedStrings[str] || str;
		} catch (e) {}
		return str;
	};
	
	getKey = function (key) {
		return widget.idenfifier + key;
	};
	
	getPref = function (key) {
		return widget.preferenceForKey(getKey(key));
	};
	
	setPref = function (key, val) {
		widget.setPreferenceForKey(val, getKey(key));
	};
	
	updateBrowserButton = function () {
		$('#button-browser img').attr('src', 'assets/icons/' + browser + '.png');
	};
	
	$(function () {
		var hurlit;
		hurlit  = new AppleGlassButton(document.getElementById('button-go'), localize('Hurl It'), hurlURL);
		browser = getPref('browser');
		if ('undefined' === typeof browser) {
			browser = browsers[0];
			setPref('browser', browser);
		}
		$('#button-browser')
			.mousedown(function (evt) {
				$(this).css({
					'background-image' : 'url(assets/button-clicked.png)'
				});
			})
			.mouseup(function (evt) {
				$(this).css({
					'background-image' : 'url(assets/button.png)'
				});
			})
			.click(function (evt) {
				var pos;
				pos = $.inArray(browser, browsers);
				evt.shiftKey ? --pos : ++pos;
				if (pos < 0) pos = browsers.length - 1;
				if (pos > browsers.length - 1) pos = 0;
				browser = browsers[pos];
				setPref('browser', browser);
				updateBrowserButton();
				isActivated();
			})
		;
		updateBrowserButton();
		isActivated();
		widget.onshow = onshow;
		widget.onhide = onhide;
	});
})();